#include <stdio.h>
#include <stdlib.h>
#include <string.h>
#include <vector>
#include <unordered_map>
#include <functional>
#include <iostream>

#include "TimeSeries.h"

struct WindowSizes {
	int accuracy;
	int windowSize;
};

struct Predictions {
	std::vector<double> labels;
  int correct;
};

void loadDatset(char*);

int predictEuclideanDistance(
		const std::vector< TimeSeries* > & testSamples,
		const std::vector< TimeSeries* > & trainSamples);

double getEuclideanDistance(
		TimeSeries* t1,
		TimeSeries* t2,
		double minValue);

double getEuclideanDistance(
		int windowLength,
		TimeSeries* ts,
		TimeSeries* q,
		double meanTs,
		double stdTs,
		double minValue,
		int w,
		bool normMean);

const std::vector<WindowSizes> fit(
		int maxWindowLength,
		int minWindowLength,
		int& accuracy,
		int& windowSize,
		bool norm);

const Predictions predict(
		int windowLength,
		int bestKnownCorrect,
		bool normMean,
		const std::vector< TimeSeries* > & testSamples,
		const std::vector< TimeSeries* > & trainSamples);

const Predictions predictEnsemble(
		std::vector<WindowSizes> windows,
		int bestKnownCorrect,
		bool normMean,
		const std::vector< TimeSeries* > & testSamples,
		const std::vector< TimeSeries* > & trainSamples);

void outputResult(
		int correct, double startTime, int testSize);

double formatError(int correct, int testSize);


